// --------------------------------------------------------------------------
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// --------------------------------------------------------------------------

import AzureCore
import Foundation
// swiftlint:disable superfluous_disable_command
// swiftlint:disable identifier_name
// swiftlint:disable line_length
// swiftlint:disable cyclomatic_complexity

/// Thread members to be added to the thread.
public struct AddChatThreadMembersRequest: Codable {
    // MARK: Properties

    /// Members to add to a chat thread.
    public let members: [ChatThreadMember]

    // MARK: Initializers

    /// Initialize a `AddChatThreadMembersRequest` structure.
    /// - Parameters:
    ///   - members: Members to add to a chat thread.
    public init(
        members: [ChatThreadMember]
    ) {
        self.members = members
    }

    // MARK: Codable

    enum CodingKeys: String, CodingKey {
        case members
    }

    /// Initialize a `AddChatThreadMembersRequest` structure from decoder
    public init(from decoder: Decoder) throws {
        let container = try decoder.container(keyedBy: CodingKeys.self)
        self.members = try container.decode([ChatThreadMember].self, forKey: .members)
    }

    /// Encode a `AddChatThreadMembersRequest` structure
    public func encode(to encoder: Encoder) throws {
        var container = encoder.container(keyedBy: CodingKeys.self)
        try container.encode(members, forKey: .members)
    }
}
