// --------------------------------------------------------------------------
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// --------------------------------------------------------------------------

import AzureCore
import Foundation
// swiftlint:disable superfluous_disable_command
// swiftlint:disable identifier_name
// swiftlint:disable line_length
// swiftlint:disable cyclomatic_complexity

public struct MultiStatusResponse: Codable {
    // MARK: Properties

    /// The list of status information for each resource in the request.
    public let multipleStatus: [IndividualStatusResponse]?

    // MARK: Initializers

    /// Initialize a `MultiStatusResponse` structure.
    /// - Parameters:
    ///   - multipleStatus: The list of status information for each resource in the request.
    public init(
        multipleStatus: [IndividualStatusResponse]? = nil
    ) {
        self.multipleStatus = multipleStatus
    }

    // MARK: Codable

    enum CodingKeys: String, CodingKey {
        case multipleStatus
    }

    /// Initialize a `MultiStatusResponse` structure from decoder
    public init(from decoder: Decoder) throws {
        let container = try decoder.container(keyedBy: CodingKeys.self)
        self.multipleStatus = try? container.decode([IndividualStatusResponse].self, forKey: .multipleStatus)
    }

    /// Encode a `MultiStatusResponse` structure
    public func encode(to encoder: Encoder) throws {
        var container = encoder.container(keyedBy: CodingKeys.self)
        if multipleStatus != nil { try? container.encode(multipleStatus, forKey: .multipleStatus) }
    }
}
